package org.vendor.connector.api.i2c;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import org.eclipse.swt.widgets.Display;
import org.vendor.connector.api.IConnection;
import org.vendor.connector.api.IConnectionManager;
import org.vendor.connector.api.ISettings;
import org.vendor.connector.api.i2c.I2cUtils;
import org.vendor.connector.api.i2c.II2cSettings;
import org.vendor.connector.api.i2c.jni.II2cDllByJNA;

public class I2cConnection implements IConnection<II2cSettings>, Runnable {
  static int timeout = 1000;
  
  private boolean connected;
  
  private static final int DEFAULT_CHANNEL_ID = 0;
  
  private static int baudRate;
  
  private static int deviceAddress;
  
  private String name;
  
  private II2cSettings i2cSettings;
  
  private boolean autoReceive = false;
  
  public I2cConnection(II2cSettings i2cSettings) throws IOException {
    init(i2cSettings);
    (new Thread(this)).start();
  }
  
  private void init(II2cSettings i2cSettings) {
    setSettings(i2cSettings);
  }
  
  public static org.vendor.connector.api.i2c.I2cConnection createConnection(II2cSettings ii2cSettings) throws IOException {
    org.vendor.connector.api.i2c.I2cConnection i2cConnector = new org.vendor.connector.api.i2c.I2cConnection(ii2cSettings);
    String baudRateStr = ii2cSettings.getfBaudRate();
    String deviceAddressStr = ii2cSettings.getfDeviceAddress();
    baudRate = I2cUtils.getbaudRateValue(baudRateStr);
    deviceAddress = I2cUtils.convertStringToInt(deviceAddressStr);
    try {
      int openResult = II2cDllByJNA.instance.I2C_OpenChannel(0, baudRate);
      if (I2cUtils.checkI2cReturn(openResult)) {
        i2cConnector.connected = true;
      } else {
        i2cConnector.connected = false;
      } 
    } catch (Exception e) {
      i2cConnector.connected = false;
      Display.getDefault().syncExec((Runnable)new Object());
      e.printStackTrace();
    } catch (Error e) {
      i2cConnector.connected = false;
      Display.getDefault().syncExec((Runnable)new Object());
      e.printStackTrace();
    } 
    return i2cConnector;
  }
  
  public void close() {
    setConnectionManager(null);
    this.connected = false;
    try {
      int closeResult = II2cDllByJNA.instance.I2C_CloseChannel(0);
      I2cUtils.checkI2cReturn(closeResult);
    } catch (Exception e) {
      Display.getDefault().syncExec((Runnable)new Object(this));
    } catch (Error e) {
      this.connected = false;
      Display.getDefault().syncExec((Runnable)new Object(this));
      e.printStackTrace();
    } 
  }
  
  public void run() {}
  
  public boolean isAutoReceive() {
    return this.autoReceive;
  }
  
  public void setAutoReceive(boolean autoReceive) {
    this.autoReceive = autoReceive;
  }
  
  public String getName() {
    return this.name;
  }
  
  public II2cSettings getSettings() {
    return this.i2cSettings;
  }
  
  public void setSettings(II2cSettings settings) {
    this.i2cSettings = settings;
  }
  
  public void setName(String name) {
    this.name = name;
  }
  
  public boolean updateSettings(II2cSettings settings) {
    return false;
  }
  
  public void setConnectionManager(IConnectionManager connectionManager) {}
  
  public void send(String data) throws IOException {}
  
  public void send(char data) throws IOException {}
  
  public boolean sendI2cCmd(int sizetowrite, byte[] inputbuffer, int sizetoread, byte[] outputbuffer) throws IOException {
    int setCmdResult = -1;
    int sendCount = 1;
    try {
      while (setCmdResult != 0 && sendCount < 10) {
        setCmdResult = II2cDllByJNA.instance.I2C_DeviceStream(0, deviceAddress, sizetowrite, inputbuffer, sizetoread, outputbuffer);
        System.out.println("setCmdResult: " + setCmdResult);
        sendCount++;
      } 
    } catch (Exception e) {
      e.printStackTrace();
      Display.getDefault().syncExec((Runnable)new Object(this));
      return false;
    } catch (Error e) {
      this.connected = false;
      Display.getDefault().syncExec((Runnable)new Object(this));
      e.printStackTrace();
    } 
    return I2cUtils.checkI2cReturn(setCmdResult);
  }
  
  public OutputStream getRemoteOutputStream() {
    return null;
  }
  
  public boolean isConnected() {
    return this.connected;
  }
  
  public InputStream getRemoteInputStream() {
    return null;
  }
  
  public static int getBaudRate() {
    return baudRate;
  }
  
  public static int getDeviceAddress() {
    return deviceAddress;
  }
  
  public void addOutputStream(OutputStream out) {}
  
  public void removeOutputStream(OutputStream out) {}
}
